#include <ctype.h>

int getchv(void);
void ungetchv(int);
int getop(char s[]);

/* getop: get next character or numeric operand */
int getop(char s[])
{

	int i, c;

	while ((s[0] = c = getchv()) == ' ' || c == '\t')
		;
	s[1] = '\0';
	if (!isdigit(c) && c != '.')
		return c;	/* not a number */
	i = 0;
	if (isdigit(c))		/* collect integer part */
		while (isdigit(s[++i] = c = getchv()))
			;
	if (c == '.')		/* collect fraction part */
		while (isdigit(s[++i] = c = getchv()))
			;
	s[i] = '\0';
	if (c != EOF)
		ungetchv(c);
	return NUMBER;
}

#define BUFSIZE 100

char buf[BUFSIZE];	/* buffer for ungetch */
int bufp = 0;		/* next free position in buf */

int getchv(void) /* get a (possibly pushed-back) character */
{
	return (bufp > 0) ? buf[--bufp] : getchar();
}

void ungetchv(int c)	/* push character back on input */
{
	if (bufp >= BUFSIZE)
		printf("ungetch: too many characters\n");
	else
		buf[bufp++] = c;
}
