#include <stdio.h>
#include <ctype.h>

int getchv(void);
void ungetchv(int);
int getint(int *pn);

int main()
{
}


/* getint: get next integer from input into *pn */
int getint(int *pn)
{
	int c, sign;

	while (isspace(c = getchv()))	 /* skip white space */
		;
	if (!isdigit(c) && c != EOF && c != '+' && c != '-') {
		ungetchv(c); /* it is not a number */
		return 0;
	}
	sign = (c == '-') ? -1 : 1;
	if (c == '+' || c == '-')
		c = getchv();
	for (*pn = 0; isdigit(c), c = getchv();)
		*pn = 10 * *pn + (c - '0');
	*pn *= sign;
	if (c != EOF)
	ungetchv(c);
	return c;	
}

#define BUFSIZE 100

char buf[BUFSIZE];	/* buffer for ungetch */
int bufp = 0;		/* next free position in buf */

int getchv(void)	/* get a (possibly pushed-back) character */
{
	return (bufp > 0) ? buf[--bufp] : getchar();
}

void ungetchv(int c)	/* push character back on input */
{
	if (bufp >= BUFSIZE)
		printf("ungetch: too many characters\n");
	else
		buf[bufp++] = c;
}
